#include <SoftwareSerial.h>
#include <Stepper.h>

#define stepsperrevolution 2048
#define stepangle stepsperrevolution / 360*1/4

#define stepper1 2
#define stepper2 8
#define stepper3 7
#define stepper4 4

Stepper stepper(stepsperrevolution, stepper1, stepper3, stepper2, stepper4);

#define leften 11
#define leftph 12
#define righten 10
#define rightph 13

#define sensdx 3

#define sserial 5
#define sserial2 6


#define c 3.875 //UNKNOWN  //TBD- need data. This is the constant to be used in movement equations. It is distance(mm)/(speed (uint8_t) *time (ms))
#define c2 20.7 //UNKNOWN //
#define wheeldiam 70 //mm
#define carlen = 152.4 //6 in in mm


#define spd1 155 //left
#define spd2 120 //right

SoftwareSerial port2(sensdx, 9);
SoftwareSerial port3(sserial, sserial2); //second port to stop issues with buffer- port2 buffer over time, so I will activate port 3 buffer when I dont want to read from 2 to prevent this

float carposx = 0;
float carposy = 0;
float cardeltax = 0;
float cardeltay = 0;
float carangle = 0;
int stepperangle = 0;
bool stepperdir; //false left true right

int indata[8];

int outdata[12][2];

void setup() {
  
 stepper.setSpeed(10);
 Serial.begin(9600);
 delay(1000);
 port2.begin(1200);
 delay(1000);
 port3.begin(1200);
 delay(1000);
 port3.listen();
 
 Serial.setTimeout(10000);


}


void loop() {

}





void serialEvent() {
 Serial.readStringUntil('<');
 String input = Serial.readStringUntil('>');
// Serial.println(input);
 
 int pointer = 0;
 for(int i = 0; i < input.length(); i++){
  int n = 1;
  if(input.substring(i,i+1) != ","){
    if(input.substring(i,i+1) == ">"){break;}
    while(input.substring(i+n-1,i+n) != "," && input.substring(i+n-1,i+n) != ">"){n++;}
    n--;
    indata[pointer] = input.substring(i,i+n).toInt();
    pointer++;
  }
  i+= n-1;
 }

/* for(int i = 0; i < sizeof(indata)/sizeof(indata[0]); i++){
  Serial.println(indata[i]);
 }
*/
 domove();
}

void domove()
{
  
 if(indata[0] == 1){
  moveStraight(indata[1],false);
 }
  else if(indata[0] == 2){
  moveStraight(indata[1],true);
  }
  else if(indata[0] == 3){
  moveAngle(indata[1],false);
  }
  else if(indata[0] == 4){
  moveAngle(indata[1],true);
  }
  else if(indata[0] == 9){
  scan();
  sendpoints();
  }
}

void scan()
{ 
  int pointer = 0;
  for(int i = 0; i < 180; i += 15){
    if(stepperdir)
    {
  stepper.step(15*stepangle);
  stepperangle += 15;
    }
    else{
  stepper.step(-15*stepangle);
  stepperangle -= 15;
    }
  port2.listen();
  int distance = port2.parseInt();
  port3.listen();
  float pointx = carposx + distance * cos(3.1415/180*(stepperangle + carangle)) + carposx;
  float pointy = carposy + distance * sin(3.1415/180*(stepperangle + carangle)) + carposy;
  int intpx = round(pointx);
  int intpy = round(pointy);
  outdata[pointer][0] = intpx;
  outdata[pointer][1] = intpy;
  pointer++;
  }
  stepperdir = !stepperdir;
}

void sendpoints()
{
  String outstring = "<1,";
 for(int i = 0; i < sizeof(outdata) / sizeof(outdata[0]); i++){
  outstring += outdata[i][0];
  outstring += ",";
  outstring += outdata[i][1];
  outstring += ",";
 }
 outstring += ">";
 Serial.println(outstring);
}

void moveStraight(int distance, bool dir)
{

int dur = 100*round(distance/c);

  
 if(dir)
  {
   analogWrite(leften,spd1);
   analogWrite(righten,spd2);
   digitalWrite(leftph,LOW);
   digitalWrite(rightph,LOW);
   delay(dur);
  }
 else
  {
   analogWrite(leften,spd1);
   analogWrite(righten,spd2);
   digitalWrite(leftph,HIGH);
   digitalWrite(rightph,HIGH);
   delay(dur); 
  }
   digitalWrite(leften,LOW);
   digitalWrite(righten,LOW);
   digitalWrite(leftph,LOW);
   digitalWrite(rightph,LOW);
   
   cardeltax = cos(3.1415/180*(carangle))*distance;
   cardeltay = sin(3.1415/180*(carangle))*distance;
   carposx += cardeltax;
   carposy += cardeltay;
}



void moveAngle(int angle, bool dir)
{
  int dur = 100*round(angle / c2);
  Serial.print(dur);
   if(dir)
  {
    Serial.print("true");
   analogWrite(leften,spd1);
   analogWrite(righten,spd2);
   digitalWrite(leftph,HIGH);
   digitalWrite(rightph,LOW);
   delay(dur);
  }
 else
  {
    Serial.print("false");
   analogWrite(leften,spd1);
   analogWrite(righten,spd2);
   digitalWrite(leftph,LOW);
   digitalWrite(rightph,HIGH);
   delay(dur); 
  }
   digitalWrite(leften,LOW);
   digitalWrite(righten,LOW);
   digitalWrite(leftph,LOW);
   digitalWrite(rightph,LOW);
   
  carangle += angle;
}
